## Frontline

### A Web Application for building Web Applications ([DEMO](http://frontline.rbho.me/applications))

**Using Demo:**

To load demo application insert "/home/vagrant/projects/CMS" into path field and something into name field.
<br>
Click "Load Application".

To generate a new application insert "/home/vagrant/projects/APP_NAME_HERE" into path field and something into name field.
<br>
Click "Generate Application".

Database credentials:
  
  - type: mysql
  - name: frontline
  - user: root
  - pass: mrp

### Wait, what is this all about?

Basically it is a web interface for [Enginery Builder](https://github.com/espresso/enginery).

It allow to "visually" build applications, CRUDify controllers, routes, models etc. as well as run migrations, specs, execute bundler and git commands, manage assets etc.


## Install

```bash
$ gem install frontline
```

\+ `$ rbenv rehash` if you are using `rbenv`.

## Use

Simply run `frontline` from terminal:

```bash
$ frontline
```

This will start `Frontline` application on port `5000`.

Now open your browser at [localhost:5000](http://localhost:5000) and start manage your applications.

To start `Frontline` on another port use `-p` option:

```bash
$ frontline -p PortNumber
```

To generate a new application set application name and full path to the folder that will hold application sources.

If folder at given path exists it should be empty.

If it does not it will be created.

<img src="https://raw.github.com/espresso/frontline/master/images/0.png">

If you already have some application it can be loaded into `Frontline` same way - provide application name, full path to application root and click "Load" button.

To start manage some application simply click on its name.

To remove some application from list click the icon beside application name.

After you entered some application, the top menu will contain a dropdown with application names from where you can easily switch managed application.


## Contributing

  - Fork Frontline repository
  - Make your changes
  - Submit a pull request

<hr>
<p>
  Issues/Bugs:
  <a href="https://github.com/espresso/frontline/issues">
    github.com/espresso/frontline/issues</a>
</p>
<p>
  Mailing List: <a href="https://groups.google.com/forum/?fromgroups#!forum/espresso-framework">
  groups.google.com/.../espresso-framework</a>
</p>
<p>
  IRC channel: #espressorb on irc.freenode.net
</p>

### Author - [Silviu Rusu](https://github.com/slivu).  License - [MIT](https://github.com/espresso/frontline/blob/master/LICENSE).
